﻿/* ******************************************************************************
 ATTRIBUTE PURPOSE: 
 1. Base Attribute to clean and prep the wiki links rows into edges Link A -> Link B format.
***************************************************************************************** */

import WikipediaStats, Std;

wikiedge_rec := record
  unsigned4 FromId;
	unsigned4 ToId;
end;

wikiedge_rec to_wikiedge_rec(WikipediaStats._FileRawPageEdges L, INTEGER C) := TRANSFORM
  SET OF STRING linkset := Std.Str.SplitWords(l.links, ' ');
  self.FromId := l.FromId;
	self.ToId := (unsigned4)linkset[C];
end;

export PageEdges := NORMALIZE(WikipediaStats._fileRawPageEdges, LEFT.ToLinkCount, to_wikiedge_rec(LEFT,COUNTER)) : PERSIST('~wikipedia::edges');